Index: /palm/trunk/SCRIPTS/NCL/.ncl_preferences
===================================================================
--- /palm/trunk/SCRIPTS/NCL/.ncl_preferences	(revision 161)
+++ /palm/trunk/SCRIPTS/NCL/.ncl_preferences	(revision 162)
@@ -11,8 +11,8 @@
 ___'file_out'________[path/name; i.e. ~/.../test]_______________default = test____________[ALL]
 test
-___start_time_step___[0;1;...]__________________________________default = 1_______________[ALL]
-1
-___end_time_step_____[1;2;...]__________________________________default = nt______________[ALL]
-nt
+___start_time_step___[0;1;...]__________________________________default = t(0)____________[ALL]
+t(0)
+___end_time_step_____[1;2;...]__________________________________default = t(end)__________[ALL]
+t(end)
 ___no_columns________[1;2;...]__________________________________default = 1_______________[ALL]
 1
@@ -35,8 +35,20 @@
 ___max_z_____________[100;1000;...]_____________________________default = max(z_u)________[PR] 
 max(z_u)
+___over______________[0] or [1]_________________________________default = 0_______________[PR+TS]
+0
+___vector____________[0] or [1]_________________________________default = 0_______________[CS]
+0
+___'vec1'____________[,u,;,v,;...]______________________________default = vec1____________[CS]
+vec1
+___'vec2'____________[,u,;,v,;...]______________________________default = vec2____________[CS]
+vec2
+__'plotvec'__________[,u,;,v,;...]______________________________default = plotvec_________[CS]
+plotvec
+___ref_mag___________[0.1;0.02;...]_____________________________default = 0.05____________[CS]
+0.05
+___'mode'____________[Fill], [Line] or [Both]___________________default = Fill____________[CS]
+Fill
 ___'sort'____________[time] or [layer]__________________________default = time____________[CS]
 time
-___'mode'____________[Fill], [Line] or [Both]___________________default = Fill____________[CS]
-Fill
 ___'fill_mode'_______[AreaFill], [RasterFill] or [CellFill]_____default = AreaFill________[CS]
 AreaFill
@@ -49,27 +61,15 @@
 ___yzc_______________[0] or [1]_________________________________default = 0_______________[CS]
 0
-___xs________________[0,1,...]__________________________________default = 0_______________[CS]
-0
-___xe________________[1;2;...]__________________________________default = xdim____________[CS]
+___xs________________[0,1,...]__________________________________default = x0______________[CS+PR]
+x0
+___xe________________[1;2;...]__________________________________default = xdim____________[CS+PR]
 xdim
-___ys________________[0;1;...]__________________________________default = 0_______________[CS]
-0
+___ys________________[0;1;...]__________________________________default = y0______________[CS]
+y0
 ___ye________________[1;2;...]__________________________________default = ydim____________[CS]
 ydim
-___zs________________[0;1;...]__________________________________default = 0_______________[CS]
-0
+___zs________________[0;1;...]__________________________________default = z0______________[CS]
+z0
 ___ze________________[1;2;...]__________________________________default = zdim____________[CS]
 zdim
-___vector____________[0] or [1]_________________________________default = 0_______________[CS]
-0
-___'vec1'____________[,u,;,v,;...]______________________________default = vec1____________[CS]
-vec1
-___'vec2'____________[,u,;,v,;...]______________________________default = vec2____________[CS]
-vec2
-__'plotvec'__________[,u,;,v,;...]______________________________default = plotvec_________[CS]
-plotvec
-___ref_mag___________[0.1;0.02;...]_____________________________default = 0.05____________[CS]
-0.05
-___over______________[0] or [1]_________________________________default = 0_______________[TS+PR]
-0
 ___end of file ".ncl_preferences"_____________________________________________________________
Index: /palm/trunk/SCRIPTS/NCL/cross_sections.ncl
===================================================================
--- /palm/trunk/SCRIPTS/NCL/cross_sections.ncl	(revision 161)
+++ /palm/trunk/SCRIPTS/NCL/cross_sections.ncl	(revision 162)
@@ -61,25 +61,25 @@
    if ( .not. isvar("sort") ) then   			; sort of plots
       sort = "time"
-      if (parameter(37) .NE. "time") then
-         sort = parameter(37)  
+      if (parameter(51) .NE. "time") then
+         sort = parameter(51)  
       end if
    end if 
    if ( .not. isvar("mode") ) then   			; pattern of contour plots
       mode = "Fill"
-      if (parameter(39) .NE. "Fill") then
-         mode = parameter(39)  
+      if (parameter(49) .NE. "Fill") then
+         mode = parameter(49)  
       end if
    end if
    if ( .not. isvar("fill_mode") ) then 		; pattern of filling 
       fill_mode = "AreaFill"
-      if (parameter(41) .NE. "AreaFill") then
-         mode = parameter(41)  
+      if (parameter(53) .NE. "AreaFill") then
+         mode = parameter(53)  
       end if 
    end if
    if ( .not. isvar("shape") ) then   			; keeping of aspect ratio
       shape = 1
-      if (parameter(43) .NE. "1") then
-         shape = stringtointeger(parameter(43)) 
-         if (stringtointeger(parameter(43)) .NE. 0) then
+      if (parameter(55) .NE. "1") then
+         shape = stringtointeger(parameter(55)) 
+         if (stringtointeger(parameter(55)) .NE. 0) then
             print(" ")
             print("Please set 'shape' to 0 or 1")
@@ -95,7 +95,7 @@
    if ( .not. isvar("xyc") ) then   			; turn xy cross-section on or off
       xyc = 0
-      if (parameter(45) .NE. "0") then
-         xyc = stringtointeger(parameter(45)) 
-         if (stringtointeger(parameter(45)) .NE. 1) then
+      if (parameter(57) .NE. "0") then
+         xyc = stringtointeger(parameter(57)) 
+         if (stringtointeger(parameter(57)) .NE. 1) then
             print(" ")
             print("Please set 'xyc' to 0 or 1")
@@ -107,7 +107,7 @@
    if ( .not. isvar("xzc") ) then   			; turn xz cross-section on or off 
       xzc = 0
-      if (parameter(47) .NE. "0") then
-         xzc = stringtointeger(parameter(47)) 
-         if (stringtointeger(parameter(47)) .NE. 1) then
+      if (parameter(59) .NE. "0") then
+         xzc = stringtointeger(parameter(59)) 
+         if (stringtointeger(parameter(59)) .NE. 1) then
             print(" ")
             print("Please set 'xzc' to 0 or 1")
@@ -119,7 +119,7 @@
    if ( .not. isvar("yzc") ) then   			; turn yz cross-section on or off 
       yzc = 0
-      if (parameter(49) .NE. "0") then
-         yzc = stringtointeger(parameter(49)) 
-         if (stringtointeger(parameter(49)) .NE. 1) then
+      if (parameter(61) .NE. "0") then
+         yzc = stringtointeger(parameter(61)) 
+         if (stringtointeger(parameter(61)) .NE. 1) then
             print(" ")
             print("Please set 'yzc' to 0 or 1")
@@ -129,22 +129,4 @@
       end if
    end if
-   if ( .not. isvar("xs") ) then     			; start of x-coordinate range 
-      xs = 0
-      if (parameter(51) .NE. "0") then
-         xs = stringtointeger(parameter(51))
-      end if
-   end if 
-   if ( .not. isvar("ys") ) then     			; start of y-coordinate range
-      ys = 0
-      if (parameter(55) .NE. "0") then
-         ys = stringtointeger(parameter(55))
-      end if
-   end if
-   if ( .not. isvar("zs") ) then     			; start of z-coordinate range
-      zs = 0
-      if (parameter(59) .NE. "0") then
-         zs = stringtointeger(parameter(59))
-      end if
-   end if  
 
    if (xyc .EQ. 0 .AND. xzc .EQ. 0 .AND. yzc .EQ. 0) then
@@ -180,7 +162,7 @@
    if ( .not. isvar("vector") ) then   			; sort of plots
       vector = 0
-      if (parameter(63) .NE. "0") then
-         vector = stringtointeger(parameter(63)) 
-         if (stringtointeger(parameter(63)) .NE. 1) then
+      if (parameter(39) .NE. "0") then
+         vector = stringtointeger(parameter(39)) 
+         if (stringtointeger(parameter(39)) .NE. 1) then
             print(" ")
             print("Please set 'vector' to 0 or 1")
@@ -192,6 +174,6 @@
    if ( .not. isvar("ref_mag") ) then   			; sort of plots
       ref_mag = 0.05
-      if (parameter(71) .NE. "0.05") then
-         ref_mag = stringtofloat(parameter(71))   
+      if (parameter(47) .NE. "0.05") then
+         ref_mag = stringtofloat(parameter(47))   
       end if
    end if 
@@ -208,8 +190,77 @@
    print(" ")
    dim   = dimsizes(vNam)
+
+   ; ***************************************************
+   ; check for kind of input file
+   ; ***************************************************
+
+   check_3d = True
+   do varn=0,dim-1
+      checkxy = isStrSubset( vNam(varn),"xy")
+      checkxz = isStrSubset( vNam(varn),"xz")
+      checkyz = isStrSubset( vNam(varn),"yz")
+      if (checkxy .OR. checkxz .OR. checkyz) then
+         check_3d = False
+         break
+      end if
+   end do
+   if (.not. check_3d) then
+      if (xyc .EQ. 1 .AND. .not. checkxy) then
+         print(" ")
+         print("Your input file doesn't have values for xy cross-sections")
+         if (checkxz)then
+            print("Select another input file or xz cross-sections")
+         else
+            print("Select another input file or yz cross-sections")
+         end if
+         print(" ")
+         exit
+      else
+         print(" ")
+         print("Your input file contains xy data")
+         print(" ") 
+      end if
+      if (xzc .EQ. 1 .AND. .not. checkxz) then
+         print(" ")
+         print("Your input file doesn't have values for xz cross-sections")
+         if (checkxy)then
+            print("Select another input file or xy cross-sections")
+         else
+            print("Select another input file or yz cross-sections")
+         end if
+         print(" ")
+         exit
+      else
+         print(" ")
+         print("Your input file contains xz data")
+         print(" ")
+      end if
+      if (yzc .EQ. 1 .AND. .not. checkyz) then
+         print(" ")
+         print("Your input file doesn't have values for yz cross-sections")
+         if (checkxy)then
+            print("Select another input file or xy cross-sections")
+         else
+            print("Select another input file or xz cross-sections")
+         end if
+         print(" ")
+         exit
+      else
+         print(" ")
+         print("Your input file contains yz data")
+         print(" ")
+      end if
+   else
+      print(" ")
+      print("Your input file: '"+file_in+"'")
+      print("contains 3d or other data")
+      print(" ")
+   end if
+   
    if (dim .EQ. 0) then
       print(" ")
-      print("There are no data on file")
+      print("There is no data on file")
       print(" ")
+      exit
    end if
 
@@ -241,8 +292,11 @@
    cs_res@lgLabelFontHeightF     = .02
    cs_res@txFontHeightF          = .02
+   cs_res@cnLevelSelectionMode    = "ManualLevels"
+
    cs_resP = True
    cs_resP@txString               = f@title
    cs_resP@txFuncCode             = "~"         	; necessary for title
    cs_resP@txFontHeightF          = .02
+   
   
    if ( mode .eq. "Fill" ) then
@@ -268,44 +322,59 @@
    ; *********************************************
 
-   t    = f->time
-   nt = dimsizes(t)
-     
-   ; *********************************************	
+   t_all = f->time
+   nt = dimsizes(t_all)
+   delta_t = t_all(nt-1)/nt
+
+   ; ****************************************************	
    ; start of time step and different types of mistakes that could be done
-   ; *********************************************
+   ; ****************************************************
 
    if ( .not. isvar("start_time_step") ) then   	
-      start_time_step = 0
-      if (parameter(13) .NE. "1") then
-         if (parameter(13) .LT. "1")
-            print(" ")
-            print("Begin with time step 1")
+      start_time_step=t_all(0)/3600
+      if (parameter(13) .NE. "t(0)") then
+         if (stringtodouble(parameter(13)) .GT. t_all(nt-1)/3600)
+            print(" ")
+            print("'start_time_step' = "+ parameter(13) +"h is greater than last time step = " + t_all(nt-1)+"s = "+t_all(nt-1)/3600+"h")
+            print(" ")
+            print("Please select another 'start_time_step'")
             print(" ")
             exit
          end if
-         if (stringtointeger(parameter(13)) .GT. nt)
-            print(" ")
-            print("'start_time_step' = "+ parameter(13) +" is greater than available time steps = " + (nt))
+         if (stringtofloat(parameter(13)) .LT. t_all(0)/3600)
+            print(" ")
+            print("'start_time_step' = "+ parameter(13) +"h is lower than first time step = " + t_all(0)+"s = "+t_all(0)/3600+"h")
+            print(" ")
+            print("Please select another 'start_time_step'") 
             print(" ")
             exit
          end if
-         start_time_step = stringtointeger(parameter(13))-1  
+         start_time_step=stringtodouble(parameter(13)) 
       end if
    else 
-      if (start_time_step .LE. 0)
-         print(" ")
-         print("Begin with time step 1")
+      if (start_time_step .GT. t_all(nt-1)/3600)
+         print(" ")
+         print("'start_time_step' = "+ start_time_step +"h is greater than last time step = " + t_all(nt-1)+"s = "+t_all(nt-1)/3600+"h")
+         print(" ")
+         print("Please select another 'start_time_step'")
          print(" ")
          exit
       end if
-      if (start_time_step .GT. nt)
-         print(" ")
-         print("'start_time_step' = "+ start_time_step +" is greater than available time steps = " + (nt)) 
+      if (start_time_step .LT. t_all(0)/3600)
+         print(" ")
+         print("'start_time_step' = "+ start_time_step +"h is lower than first time step = " + t_all(0)+"s = "+t_all(0)/3600+"h")
+         print(" ")
+         print("Please select another 'start_time_step'")
          print(" ")
          exit
       end if
-      start_time_step = start_time_step - 1
-   end if
-
+   end if
+   start_time_step = start_time_step*3600
+   do i=0,nt-1     
+      if (start_time_step .GE. t_all(i)-delta_t/2 .AND. start_time_step .LT. t_all(i)+delta_t/2)then
+         st=i
+         break
+      end if
+   end do
+        
    ; ****************************************************
    ; end of time step and different types of mistakes that could be done
@@ -313,48 +382,76 @@
 
    if ( .not. isvar("end_time_step") ) then     	
-      end_time_step = nt-1
-      if (parameter(15) .NE. "nt") then
-         if (parameter(15) .LE. "0")
-            print(" ")
-            print("'end_time_step' = "+parameter(15)+ " is too small; 'end_time_step' should be at least 1 ")
+      end_time_step = t_all(nt-1)/3600
+      if (parameter(15) .NE. "t(end)") then
+         if (stringtodouble(parameter(15)) .LT. t_all(0)/3600)
+            print(" ")
+            print("'end_time_step' = "+parameter(15)+ "h is lower than first time step = " + t_all(0)+"s = "+t_all(0)/3600+"h")
+            print(" ")
+            print("Please select another 'end_time_step'")
             print(" ")
             exit
          end if
-         if (stringtointeger(parameter(15)) .GT. nt)
-            print(" ")
-            print("'end_time_step' = "+ parameter(15) +" is greater than available time steps = " + (nt))
+         if (stringtodouble(parameter(15)) .GT. t_all(nt-1)/3600)
+            print(" ")
+            print("'end_time_step' = "+ parameter(15) +"h is greater than last time step = " + t_all(nt-1)+"s = "+t_all(nt-1)/3600+"h")
+            print(" ")
+            print("Please select another 'end_time_step'")  
             print(" ")
             exit
          end if
-         if (stringtointeger(parameter(15)) .LT. stringtointeger(parameter(13)) )
-            print(" ")
-            print("'end_time_step' = "+ parameter(15) +" is lower than 'start_time_step' = "+parameter(15))
+         if (stringtodouble(parameter(15)) .LT. start_time_step/3600)
+            print(" ")
+            print("'end_time_step' = "+ parameter(15) +"h is lower than 'start_time_step' = "+parameter(13)+"h")
+            print(" ")
+            print("Please select another 'start_time_step' or 'end_time_step'")
             print(" ")
             exit
          end if
-         end_time_step = stringtointeger(parameter(15))-1  
+         end_time_step = stringtodouble(parameter(15))
       end if    
    else
-      if (end_time_step .LE. 0)
-         print(" ")
-         print("'end_time_step' = "+end_time_step+ " is too small; 'end_time_step' should be at least 1 ")
+      if (end_time_step .LT. t_all(0)/3600)
+         print(" ")
+         print("'end_time_step' = "+end_time_step+ "h is lower than first time step = " + t_all(0)+"s = "+t_all(0)/3600+"h")
+         print(" ")
+         print("Please select another 'end_time_step'")
          print(" ")
          exit
       end if
-      if (end_time_step .GT. nt)
-         print(" ")
-         print("'end_time_step' = "+ end_time_step +" is greater than available time steps = "+(nt))
-         print(" ") 
+      if (end_time_step .GT. t_all(nt-1)/3600)
+         print(" ")
+         print("'end_time_step' = "+ end_time_step +"h is greater than last time step = " + t_all(nt-1)+"s = "+t_all(nt-1)/3600+"h")
+         print(" ")
+         print("Please select another 'end_time_step'")  
+         print(" ")
          exit
       end if
-      if (end_time_step .LT. start_time_step)
-         print(" ")
-         print("'end_time_step' = "+end_time_step +" is lower than 'start_time_step' = "+start_time_step)
+      if (end_time_step .LT. start_time_step/3600)
+         print(" ")
+         print("'end_time_step' = "+ end_time_step +"h is lower than 'start_time_step' = "+start_time_step+"h")
+         print(" ")
+         print("Please select another 'start_time_step' or 'end_time_step'")
          print(" ")
          exit
       end if
-      end_time_step = end_time_step-1 
-   end if
-
+   end if
+   end_time_step = end_time_step*3600
+   do i=0,nt-1     
+      if (end_time_step .GE. t_all(i)-delta_t/2 .AND. end_time_step .LT. t_all(i)+delta_t/2)then
+         et=i
+         break
+      end if
+   end do 
+  
+   delete(start_time_step)
+   start_time_step=round(st,3)
+   delete(end_time_step)
+   end_time_step=round(et,3)
+
+   print(" ")
+   print("Output from "+t_all(start_time_step)/3600+"h = "+t_all(start_time_step)+"s => index = "+start_time_step)
+   print("       till "+t_all(end_time_step)/3600+"h = "+t_all(end_time_step)+"s => index = "+end_time_step)
+   print(" ")
+  
    no_time=(end_time_step-start_time_step)+1
 
@@ -365,9 +462,9 @@
    if (vector .EQ. 1) then
       if ( .not. isvar("plotvec") ) then
-         plotvec = parameter(69)
+         plotvec = parameter(45)
       end if
       if ( .not. isvar("vec1") ) then
-         vec1 = parameter(65)
-         if (parameter(65) .EQ. "vec1") then
+         vec1 = parameter(41)
+         if (parameter(41) .EQ. "vec1") then
             print(" ")
             print("Please indicate Vector 1 ('vec1') for Vector-Plot")
@@ -377,6 +474,6 @@
       end if
       if ( .not. isvar("vec2") ) then
-         vec2 = parameter(67)
-         if (parameter(67) .EQ. "vec2") then
+         vec2 = parameter(43)
+         if (parameter(43) .EQ. "vec2") then
             print(" ")
             print("Please indicate Vector 2 ('vec2') for Vector-Plot")
